#ifndef MEMMANAGER_H
#define MEMMANAGER_H

#include "copyright.h"
#include "openfile.h"
#include "bitmap.h"
#include "translate.h"

#define SWAPSIZE 4096
#define SWAPFILE "swapfile"

class MemoryManager
{
private:
	BitMap *swapBitMap;
	OpenFile *swapFile;
	TranslationEntry **physicalPage;
	int TLBPos;
	int pagePos;
	int getPageFaultPos();
	int getKillTLB();
	int getKillPage();
public:
	MemoryManager();
	~MemoryManager();
	void PageFault();
	int writeDisk(char *buff,int pos,int len);
	int readDisk(char *buff,int pos);
	int find();
	int numClear();
	void clear(int pos);
	void clearPage(int page);
	void clearTLB();
	void dump();
};

#endif
