// threadtest.cc 
//	Simple test case for the threads assignment.
//
//	Create two threads, and have them context switch
//	back and forth between themselves by calling Thread::Yield, 
//	to illustratethe inner workings of the thread system.
//
// Copyright (c) 1992-1993 The Regents of the University of California.
// All rights reserved.  See copyright.h for copyright notice and limitation 
// of liability and disclaimer of warranty provisions.

#include "copyright.h"
#include "system.h"
#include "synch.h"

int i;
int count;
int buffer[30];
const int max_size=29;
const int min_size=0;
const int max_count=100;
Condition cond("cond");
Lock lock("lock");

//----------------------------------------------------------------------
// SimpleThread
// 	Loop 5 times, yielding the CPU to another ready thread 
//	each iteration.
//
//	"which" is simply a number identifying the thread, for debugging
//	purposes.
//----------------------------------------------------------------------

void
SimpleThread(int which)
{
    int num;
    
    for (num = 0; num < 5; num++) {
	printf("*** thread %d looped %d times\n", which, num);
        currentThread->Yield();
    }
}

void producerThread(int which)
{
	lock.Acquire();
	while(count<max_count)
	{
		if(i>max_size)
		{
			i--;
			printf("producer is waiting\n");
			printf("%d -> %d\n",i+1,i);
			cond.Wait(&lock);
		}
		i++;
		count++;
		buffer[i-1]=(i-1)*10;
		printf("input %d at buffer[%d]\n",buffer[i-1],i-1);
		printf("produce %d -> %d\n",i-1,i);
		cond.Signal(&lock);
	}
	lock.Release();
}

void consumerThread(int which)
{
	lock.Acquire();
	while(count<max_count)
	{
		if(i<min_size)
		{
			i++;
			printf("consumer is waiting\n");
			printf("%d -> %d\n",i-1,i);
			cond.Wait(&lock);
		}
		i--;
		count++;
		printf("output %d at buffer[%d]\n",buffer[i+1],i+1);
		printf("consume %d -> %d\n",i+1,i);
		cond.Signal(&lock);
	}
	lock.Release();
}

//----------------------------------------------------------------------
// ThreadTest
// 	Set up a ping-pong between two threads, by forking a thread 
//	to call SimpleThread, and then calling SimpleThread ourselves.
//----------------------------------------------------------------------

void
ThreadTest()
{
	Thread *produce=new Thread("produce thread");
	Thread *consume=new Thread("consume thread");

	produce->Fork(producerThread,1);
	consume->Fork(consumerThread,2);
}

